---

 source/interpret.c |   19 +++++++++++++------
 1 file changed, 13 insertions(+), 6 deletions(-)

diff --quilt old/source/interpret.c new/source/interpret.c
--- old/source/interpret.c
+++ new/source/interpret.c
@@ -3106,6 +3106,7 @@ static char *stackDumpStr(DataValue *fp,
     const char *op;
     char *np;
     DataValue *nfp = fp;
+    Inst *pc;
 
 #ifdef DEBUG_STACK
     const char *dump;
@@ -3117,9 +3118,12 @@ static char *stackDumpStr(DataValue *fp,
 
     /* first measure the lengths */
     len = strlen(msg) + 1;
-    for (nfp = fp; nfp; nfp = FP_GET_OLD_FP(nfp)) {
+    nfp = fp;
+    do {
         len = len + FP_GET_ITEM(nfp, FP_FUNCTION_NAME).val.str.len + 1;
-    }
+        pc = FP_GET_RET_PC(nfp);
+        nfp = FP_GET_OLD_FP(nfp);
+    } while (pc);
 #ifdef DEBUG_STACK
     len += strlen(dump);
 #endif
@@ -3134,12 +3138,15 @@ static char *stackDumpStr(DataValue *fp,
     while (*op)
         *np++ = *op++;
 
-    for (nfp = fp; nfp; nfp = FP_GET_OLD_FP(nfp)) {
+    nfp = fp;
+    do {
         *np++ = '\n';
         op = FP_GET_ITEM(nfp, FP_FUNCTION_NAME).val.str.rep;
         while (*op)
             *np++ = *op++;
-    }
+        pc = FP_GET_RET_PC(nfp);
+        nfp = FP_GET_OLD_FP(nfp);
+    } while (pc);
 #ifdef DEBUG_STACK
     op = dump;
     while (*op)
@@ -3427,8 +3434,8 @@ static void disasm(Inst *inst, int nInst
 static void stackdumpframe(DataValue *arrow, DataValue *outpt, DataValue *fp,
     DataValue *sp, char topMark)
 {
-    DataValue *baseF = &FP_GET_ITEM(fp, FP_OLD_FP_INDEX);
-    DataValue *oldFP = baseF ? baseF->val.dataval : NULL;
+    Inst *retPC = FP_GET_RET_PC(fp);
+    DataValue *oldFP = retPC ? FP_GET_OLD_FP(fp) : NULL;
     DataValue *arg1 = &FP_GET_ARG_N(fp, 0);
     DataValue *fnNm = &FP_GET_ITEM(fp, FP_FUNCTION_NAME);
     DataValue *dv;
